#version 430

layout (location = 0) in vec3 position;
layout (location = 2) in vec3 normal;
layout (location = 3) in vec2 tex;
uniform mat4 model;
uniform mat4 projection;
uniform mat4 view;
uniform mat4 lightSpaceMatrix;
uniform mat4 lightSpaceMatrix2;

out vec2 uv;
out vec3 fragNormal;
out vec3 fragPos;
out vec4 fragPosLight;
out vec4 fragPosLight2;

void main(){
	gl_Position = projection * view * model * vec4(position, 1.0f);
	fragPos = vec3(model * vec4(position,1));
	fragPosLight = lightSpaceMatrix * vec4(fragPos, 1.0);
	fragPosLight2 = lightSpaceMatrix2 * vec4(fragPos, 1.0);
	fragNormal = mat3(transpose(inverse(model)))*(normal);
	uv = tex;
}