#version 430

layout(location = 0) in vec3 vertices;
layout(location = 1) in vec4 position; 
layout(location = 2) in vec4 color;

out vec4 particleColor;
out vec2 uv;

uniform vec3 cameraRight;
uniform vec3 cameraUp;
uniform mat4 projection;
uniform mat4 view;

void main()
{
    float particleSize = position.w;
	vec3 particleCenter = position.xyz;
	
	vec3 particleCenter_scaled = position.xyz + cameraRight * vertices.x * particleSize + cameraUp * vertices.y * particleSize;

	gl_Position = projection * view * vec4(particleCenter_scaled, 1.0f);

	uv = vertices.xy + vec2(0.5, 0.5);
	particleColor = color;
}